#include "quality.h"
int main(int argc, char* argv[])
{
	TiXmlDocument doc;
	FileName_Dir str;
	int controll=0;
	string ConfigFile, OutputForConfig;
    error_file="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<Ipf_errorfile>\n<filename>Preprocessing error file</filename>\n<productname>Geomagnetic forecast preprocessing module</productname>\n<stationname>diverse global</stationname>\n<code>L2</code>\n<project>AFFECTS</project>\n<Errors>\n";
	if (argc < 2 || argc > 2)
    {
		error_file+="<Step>\n<StepName>OrderFileInDir</StepName>\n<ErrorName>InputFile</ErrorName>\n<Value>1</Value>\n</Step>\n";
		str.putName_ACEMAG("ace-mag-rt-"+FileTimeForm()+".asc");
		str.putName_ACESWEPAM("ace-swepam-rt-"+FileTimeForm()+".asc");
		str.putName_DST("dst-rt-"+FileTimeForm()+".asc");
		str.putName_KP("kp-rt-"+FileTimeForm()+".asc");
		str.putName_OUTPUT("ap-fc-"+FileTimeForm());

        int contr4=DST_files_download(str.getFile_NameDST());
		if (contr4==0)
        {
            OutputForConfig+="FNDST='"+str.getFile_NameDST()+"'\n";
        }
        else
        {
            controll++;
        }

        int contr3=KP_files_download(str.getFile_NameKP());
		if (contr3==0)
        {
            OutputForConfig+="FNKP='"+str.getFile_NameKP()+"'\n";
        }
        else
        {
            controll++;
        }

		int contr=ACEMAG_files_download(str.getFile_NameACEMAG());
		if (contr==0)
        {
            OutputForConfig+="FNMAG='"+str.getFile_NameACEMAG()+"'\n";
        }
        else
        {
            controll++;
        }

        int contr2=ACESWEPAM_files_download(str.getFile_NameACESWEPAM());
		if (contr2==0)
        {
            OutputForConfig+="FNSWEPAM='"+str.getFile_NameACESWEPAM()+"'\n";
        }
        else
        {
            controll++;
        }



        error_file+="</Errors>\n";
        error_file+="</Ipf_errorfile>\n";
        if(controll>0)
        {
            file_wright(error_file, "errorfile.xml");
            return 0;
        }
        else
        {
            file_wright(error_file, "errorfile.xml");
            OutputForConfig+="FNMET='"+str.getFile_NameOutputfile()+".xml'\n";
            OutputForConfig+="FNDAT='"+str.getFile_NameOutputfile()+".asc'\n/\n";
            CongFileCreation(OutputForConfig, "farm_nrt.cfg");
            return 0;
        }
    }
	else
	{
		error_file+="<Step>\n<StepName>OrderFileInDir</StepName>\n<ErrorName>InputFile</ErrorName>\n<Value>0</Value>\n</Step>\n";
		ifstream infile(argv[1]);
		if(infile)
		{
            error_file+="<Step>\n<StepName>OrderFileExist</StepName>\n<ErrorName>InputFileExist</ErrorName>\n<Value>0</Value>\n</Step>\n";
            doc= loadData(argv[1]);
            TiXmlNode* node(&doc);
            str.visitNode(node,0,str);
            str.Dir_corect();
            str.Name_corect();

            if (str.getFile_DirInput()!="" && str.getFile_NameDST()!="")
            {
                int contrd=DST_files_download((str.getFile_DirInput()+str.getFile_NameDST()));
                if (contrd==0)
                {
                    OutputForConfig+="FNDST='"+str.getFile_DirInput()+str.getFile_NameDST()+"'\n";
                }
                else
                {
                    controll++;
                }
            }
            else
            {
                str.putName_DST("dst-rt-"+FileTimeForm()+".asc");
		        int contrd2=DST_files_download(str.getFile_NameDST());
                if (contrd2==0)
                {
                    OutputForConfig+="FNDST='"+str.getFile_NameDST()+"'\n";
                }
                else
                {
                    controll++;
                }
            }


            if (str.getFile_DirInput()!="" && str.getFile_NameKP()!="")
            {
                int contrkp=KP_files_download((str.getFile_DirInput()+str.getFile_NameKP()));
                if (contrkp==0)
                {
                    OutputForConfig+="FNKP='"+str.getFile_DirInput()+str.getFile_NameKP()+"'\n";
                }
                else
                {
                    controll++;
                }
            }
            else
            {
                str.putName_KP("kp-rt-"+FileTimeForm()+".asc");
		        int contrkp2=KP_files_download(str.getFile_NameKP());
                if (contrkp2==0)
                {
                    OutputForConfig+="FNKP='"+str.getFile_NameKP()+"'\n";
                }
                else
                {
                    controll++;
                }
            }

            int contr=FilesInXmlTest((str.getFile_DirInput()+str.getFile_NameACEMAG()));
            if (contr==0)
            {
                OutputForConfig+="FNMAG='"+str.getFile_DirInput()+str.getFile_NameACEMAG()+"'\n";
            }
            else if(str.getFile_DirInput()=="" && str.getFile_NameACEMAG()=="")
            {
                str.putName_ACEMAG("ace-mag-rt-"+FileTimeForm()+".asc");
                int contr2=ACEMAG_files_download(str.getFile_NameACEMAG());
                if (contr2==0)
                {
                        OutputForConfig+="FNMAG='"+str.getFile_NameACEMAG()+"'\n";
                }
                else
                {
                    controll++;
                }
            }
            else
            {
                int contr22=ACEMAG_files_download((str.getFile_DirInput()+str.getFile_NameACEMAG()));
                if (contr22==0)
                {
                        OutputForConfig+="FNMAG='"+str.getFile_DirInput()+str.getFile_NameACEMAG()+"'\n";
                }
                else
                {
                    controll++;
                }
            }

            int contrsw=FilesInXmlTest((str.getFile_DirInput()+str.getFile_NameACESWEPAM()));
            if (contrsw==0)
            {
                OutputForConfig+="FNSWEPAM='"+str.getFile_DirInput()+str.getFile_NameACESWEPAM()+"'\n";
            }
            else if(str.getFile_DirInput()=="" && str.getFile_NameACESWEPAM()=="")
            {
                str.putName_ACESWEPAM("ace-swepam-rt-"+FileTimeForm()+".asc");
                int contrsw2=ACESWEPAM_files_download(str.getFile_NameACESWEPAM());
                if (contrsw2==0)
                {
                        OutputForConfig+="FNSWEPAM='"+str.getFile_NameACESWEPAM()+"'\n";
                }
                else
                {
                    controll++;
                }
            }
            else
            {
                int contrsw3=ACESWEPAM_files_download((str.getFile_DirInput()+str.getFile_NameACESWEPAM()));
                if (contrsw3==0)
                {
                        OutputForConfig+="FNSWEPAM='"+str.getFile_DirInput()+str.getFile_NameACESWEPAM()+"'\n";
                }
                else
                {
                    controll++;
                }
            }



            error_file+="</Errors>\n";
            error_file+="</Ipf_errorfile>\n";
            if(str.getFile_DirOutput()!=""&& str.getFile_NameOutputfile()!="")
            {
                OutputForConfig+="FNMET='"+str.getFile_DirOutput()+str.getFile_NameOutputfile()+".xml'\n";
                OutputForConfig+="FNDAT='"+str.getFile_DirOutput()+str.getFile_NameOutputfile()+".asc'\n/\n";
            }
            else if (str.getFile_DirOutput()==""&& str.getFile_NameOutputfile()!="")
            {
                OutputForConfig+="FNMET='"+str.getFile_NameOutputfile()+".xml'\n";
                OutputForConfig+="FNDAT='"+str.getFile_NameOutputfile()+".asc'\n/\n";
            }
            else
            {
                str.putName_OUTPUT("ap-fc-"+FileTimeForm());
                OutputForConfig+="FNMET='"+str.getFile_NameOutputfile()+".xml'\n";
                OutputForConfig+="FNDAT='"+str.getFile_NameOutputfile()+".asc'\n/\n";
            }


            if(controll>0 && str.getFile_DirOutput()!="")
            {
                file_wright(error_file, str.getFile_DirOutput()+"errorfile.xml");
                return 0;
            }
            else if(controll>0 && str.getFile_DirOutput()=="")
            {
                file_wright(error_file, "errorfile.xml");
                return 0;
            }
            else
            {
                file_wright(error_file, str.getFile_DirOutput()+"errorfile.xml");
                CongFileCreation(OutputForConfig, "farm_nrt.cfg");
                return 0;
            }
            return 0;
		}
		else
		{
			error_file+=error_file="<Step>\n<StepName>OrderFileExist</StepName>\n<ErrorName>InputFileExist</ErrorName>\n<Value>1</Value>\n</Step>\n";;
			str.putName_ACEMAG("ace-mag-rt-"+FileTimeForm()+".asc");
			str.putName_ACESWEPAM("ace-swepam-rt-"+FileTimeForm()+".asc");
            str.putName_DST("dst-rt-"+FileTimeForm()+".asc");
            str.putName_KP("kp-rt-"+FileTimeForm()+".asc");
            str.putName_OUTPUT("ap-fc-"+FileTimeForm());

            int contr1=DST_files_download(str.getFile_NameDST());
            if (contr1==0)
            {
                OutputForConfig+="FNDST='"+str.getFile_NameDST()+"'\n";
            }
            else
            {
                controll++;
            }

            int contr2=KP_files_download(str.getFile_NameKP());
            if (contr2==0)
            {
                OutputForConfig+="FNKP='"+str.getFile_NameKP()+"'\n";
            }
            else
            {
                controll++;
            }

            int contr3=ACEMAG_files_download(str.getFile_NameACEMAG());
            if (contr3==0)
            {
                OutputForConfig+="FNMAG='"+str.getFile_NameACEMAG()+"'\n";
            }
            else
            {
                controll++;
            }

            int contr4=ACESWEPAM_files_download(str.getFile_NameACESWEPAM());
            if (contr4==0)
            {
                OutputForConfig+="FNSWEPAM='"+str.getFile_NameACESWEPAM()+"'\n";
            }
            else
            {
                controll++;
            }

            error_file+="</Errors>\n";
            error_file+="</Ipf_errorfile>\n";
            if(controll>0)
            {
                file_wright(error_file, "errorfile.xml");
                return 0;
            }
            else
            {
                file_wright(error_file, "errorfile.xml");
                OutputForConfig+="FNMET='"+str.getFile_NameOutputfile()+".xml'\n";
                OutputForConfig+="FNDAT='"+str.getFile_NameOutputfile()+".asc'\n/\n";
                CongFileCreation(OutputForConfig, "farm_nrt.cfg");
                return 0;
            }
            return 0;
		}
	}
	return 0;
}
